Fight for the Internet 1!

Friday, December 28, 2012

Compiling btnx for Ubuntu 12.04 and 12.10 and beyond (and Fedora too)

This is a quick and dirty guide how to compile btnx for yourself to get it to work on your Ubuntu or Kubuntu or Fedora systems.

You will need to compile both the program btnx and the program btnx-config.

This guide isn't necessarily for beginners but I will try to keep it simple.

UPDATE: I have found someone who is taking stewardship of the btnx project. He has moved the code from the derelict bazaar repos on Launchpad (one of which has permanently disappeared) and created a github repository for the project(s). He has also mainlined my patches and is tracking down other bugfixes on forks. I tested his code on Fedora 18, 19, Ubuntu 12.04, 13.04 and 13.10. All worked.

The instructions have been simplfied accordingly.

Compiling on Ubuntu

The compilation process for Ubuntu is almost exactly the same as for Fedora.

(0) In general, you will need to be able to compile programs on your Ubuntu machine. You should have the package "build-essential" installed already.

(1) Grab the program source files.

For the btnx-config page, you want to download

For the btnx page, you want to download

(2) Open up your favorite terminal. To install the btnx dependencies, do the following:
sudo apt-get install libdaemon-dev libgtk2.0-dev libglade2-dev
(3)  Navigate there and run './configure' (without quotes), and then 'make' (without quotes) and finally 'make install' (without quotes).

(4) Now both programs of btnx and btnx-config are installed on your system.

Compiling on Fedora

The compilation process for Fedora is almost exactly the same as for Ubuntu.

(0) In general, you will need to be able to compile programs on your Ubuntu machine. You should have the packages to compile and build programs installed already. To this in Fedora, run the following command:
sudo yum groupinstall "Development Tools" "Development Libraries"
This might be a bit overkill since it installs a lot, and you can remove this group when you are done.

(1) Grab the program source files.

For the btnx-config page, you want to download
For the btnx page, you want to download
(2) Open up your favorite terminal. To install the btnx dependencies, do the following:
sudo yum install libdaemon-devel gtk2-devel libglade2-devel
(3)  Navigate there and run './configure' (without quotes), and then 'make' (without quotes) and finally 'make install' (without quotes).

(4) Now both programs of btnx and btnx-config are installed on your system.


Error message:
failed to execute command /etc/init.d/btnx restart
Cause: You probably don't have the little dongle for the USB mouse plugged in. At least I always get this error if I try to use the btnx-config program and don't have my mouse plugged in yet.


It may appear in your applications-menus, but I have noticed a problem with using inside KDE. It asks for the ROOT password, not my user password with elevated privileges. I'm not sure how to fix this, but I'd love to find out. It's not a big deal for me though.

Hope that helps anyone.

Friday, December 14, 2012

HTTPS Everywhere Tweak

In the latest version of the Firefox Plugin "HTTPS Everywhere" I have been inundated with very annoying alerts asking me to save a discovered rule for HTTPS, even including saving an already existing rule. [It has asked me to save YouTube no again and again less than 20 times in the past month.]

So finally I had enough of this and I opened the almighty Firefox page "about:config" (without quotes). Then I searched through the options until I found what I was looking for.

The option to toggle is:


I set it to "true" and now I am no longer prompted to accepting or saving a rule in Firefox. It seems to work like I want, though I find it still suffers from the same problem the add-on had before. You can disable a rule, and generally it doesn't seem to work, auto-redirecting you to an HTTPS connection. This might be fixed if you close and reopen the tab or browser, but I haven't tried.

Friday, December 7, 2012

iTunes vs. DVD Information for the Quality Concnered


The purpose of this article is to discuss the merits of iTunes video quality and theoretical longevity of improving quality, versus buying DVDs with their quality.

It compares DVD Quality video (most specifically in this comparison from Amazon's DVD on-demand) and iTunes SD video. This isn't exactly Linux related, though I use iTunes through VirtualBox occasionally when I need things and *ahem* deal with the Draconian freedom suppression from Apple appropriately so I can enjoy it in Linux.

Why is this important?

Simple: If you want the best video quality you can purchase for your media, it is important to know what you will get if you purchase DVDs, or buy from online services such as iTunes, Google Video, Amazon Video, or elsewhere. In all my research online no one had concisely put all the important facts together in one place. So I had to do my own research and compile the facts, which are herein reported.

Movies (especially those available on Blu-Ray)

BluRay discs at this point are not being considered because the average BluRay movie blows iTunes off the map in terms of quality, plus you can get all sorts of extras sometimes. So a BluRay movie when you can get it is still a great cost-to-value ratio, far higher than iTunes currently. It is also unlikely that iTunes will be raising the digital quality (H26 video codec choice, audio and video quality bitrate levels, etc.) any time soon, since they just hit the 1080p mark for some content.

Results Summary

The situation simplifies down to two scenarios:
  1. If the content is available on iTunes in HD (meaning High Definition with 720p/1080p), the iTunes options is superior to even the best quality DVD you can find.
  2. If the content is available on iTunes in SD (meaning Standard Definition with 480p), the DVD options is almost certainly going to be superior to iTunes video.

    There is one potential caveat to mention. See below.
If you want more details on how I reached this conclusion, see below for some file specific comparisons.

My opinion on the matter: When  SD videos become available in HD, so will Blu-Rays of the media. Just buy those.

DVD Longevity Caveat

There is one potential caveat to mention. With iTunes there is potential for longevity. Apple recently upgraded many of their 720p iTunes videos to 1080p for free! So if you already owned it, you get it in higher quality. That's really nice. A DVD won't do that for you. But there is a twist to this generosity.

However there is no guarantee that SD video will ever be available in HD. Converting older media to remastered quality is costly and time consuming. Usually when it is done, there are also Box-sets released on the latest media. So when you see SD video remastered into HD video, you might also see a Blu-Ray Box-set for sale simultaneously.

The 1080p Twist by Apple's iTunes

This is merely an informational section: Apple very likely had the 1080p video available dating back years and years, but refrained from making it available due to playability limitations on some of their various devices. As far as the scuttlebutt on the Internet goes, Apple is handicapping content lower for one reason: compatibility with the 5th generation iPod's.

Their recent action should not be seen as a move forward, since they were consciously and actively preventing the vastly greater majority of users from enjoying superior quality, because of a very tiny few legacy users. In essence, this move was not one of going forward; it was of ceasing to suppress quality.

iTunes vs. DVD Comparison Details

iTunes does have a very very large selection of media, but not all the media is in High-Definition. In fact, most of the older media is only in Standard-Definition. For example, Hey Arnold!, El Tigre: The Adventures of Manny Rivera, Daria, and My Life as a Teenage Robot, are all only available in SD Version.
I had difficulty finding technical specs documentation. Here is what I have found so far [info source here]:

iTunes Rentals:
Apple TV HD - Main Progressive Profile at 1280xN at 4-5mps, 5.1 AC-3 Pass Through.
Apple TV SD - Main Progressive Profile at 720xN Anamorphic (creates 853xN files), likely 2.5 mbps.
iTunes SD - iPod/Basic Progressive Profile at 640xN - Now Anamorphic (which creates 853xN files), 1.5 mbps (maybe higher).

iTunes/Apple TV - iPod/Basic Progressive Profile at 640xN, 1.5 mbps.

Of course, Megabytes per second (mbps) are intimately tied to the codec in use. In the case of Apple Content as far as I know, it is H.264. DVDs are encoding using the MPEG-2 video methods.

Researching on Wikipedia I found this (and though it doesn't cite many sources I generally know this to be true from personal experience mucking about in video):

DVD-Video discs have a raw bitrate of 11.08 Mbit/s, with a 1.0 Mbit/s overhead, leaving a payload bitrate of 10.08 Mbit/s. Of this, up to 3.36 Mbit/s can be used for subtitles and a maximum of 9.80 Mbit/s can be split amongst audio and video. In the case of multiple angles the data is stored interleaved, and so there's a bitrate penalty leading to a max bitrate of 8 Mbit/s per angle to compensate for additional seek time. This limit is not cumulative, so each additional angle can still have up to 8 Mbit/s of bitrate available.
Professionally encoded videos average a bitrate of 4-5 Mbit/s with a maximum of 7–8 Mbit/s in high-action scenes.

So what does this mean? Well, the average DVD, even something with only 4.7GB of disc space capacity, has a considerably higher average video bitrate per second, compared against the average SD video from iTunes.

But bitrate doesn't include the differences in the video codecs for each data source, so I needed a better test.

Side by Side Comparison

For the comparison of the quality, I picked an episode from my Hey Arnold! DVDs. In particular, this episode is from Season 3, episode 11 Part 2 (or 11b), title "Hey Harold."

[Of note, iTunes may use a different episode numbering system than the established wide-spread one, based on date of initial public release.]

Below is a side-by-side comparison of the visual video quality:

As you can see there are notable differences in the visual quality. The color schemes are different, and there is noticeable picture compression on some of the subtle textures. The interlacing between the two videos is varied in sections, so I don't think I would label one as overall superior to the other for interlacing.

Obviously there is a slight frame size difference as well.

DVD episode

The video dimensions were 720x480. The framerate was 29.970 fps.

The video data amounted to 420MB for 11:48 of time. Doing the math that is 420 MB divided by 708 seconds, which is an average bitrate on screen of 0.5932 mbps.

Video format MPEG-2.

Of note, the audio quality was 16.20MB of AC3 192kbps of data.

iTunes SD episode

I put my money where my research is and bought the same episode of Hey Arnold! in SD using iTunes 10.5.

The video dimensions were 640x480. The framerate was 23.976 fps.

The video data amounted to 117.12 MB for 11:48 of time. Doing the math that is 420 MB divided by 708 seconds, which is an average bitrate on screen of 0.1654 mbps.

Video format is H.264.

Of note, the audio quality was 10.68MB of AAC 128kbps of data.


This conclusion is pretty straightforward for me. Looking at video bitrate alone, as well as visual quality, even non-remasterd DVDs like this can trump iTunes SD. I'm aware this is only one sample, but the cartoon Hey Arnold! has over 100 episodes that mirror this data out. That's a lot of conforming data. Even disregarding the visual differences, for the shear bitrate differences I would still go with DVD. Plus there is the freedom of playing the DVD anywhere and everywhere, contrasted against Apple's Draconian control model.

For iTunes only offers SD media, buy the DVDs instead. Otherwise, buy the iTunes HD media.

The situation simplifies down to two scenarios:
  1. If the content is available on iTunes in HD (meaning High Definition with 720p/1080p), the iTunes options is superior to even the best quality DVD you can find.
  2. If the content is available on iTunes in SD (meaning Standard Definition with 480p), the DVD options is almost certainly going to be superior to iTunes video.
iTunes SD video may be quite good for its size but it isn't as quality as most DVD video sources.

Video Alternatives

Currently these best alternative options you can find are listed below. But my conclusion is that either DVDs or iTunes are still your best bet for pure video quality. See above details for where and which.

A good table comparison is also available here: High-definition video - HD on the World Wide Web - HD Streaming

Google Video

In short summary: As of writing this (December 2012), Google Video disregarding selection of available video titles compared to its competitors, I'm actually having serious trouble finding the specifications for HD and SD video purchased through Google Play.

Some reports I have read from only several months ago claim that Google also has less HD (720p/1080p) video than their competitor(s). Unfortunately my notes don't have the citations and current Google searches fail to confirm or deny this information. If anyone wants to furnish me with detailed specs, I will be happy to list them here.

Amazon Video

In short summary: As of writing this (December 2012), Amazon Video it isn't even up to average DVD standard quality [video bitrate per second]. You can check Wikipedia articles for better details and explanation on this matter.

Furthermore, at this time Amazon Video isn't even half the quality of 720p video from iTunes.

Amazon Video appears more geared towards streaming, and their strategy currently is less about the highest quality of video available, most likely due to bandwidth limitations for most customers.

Saturday, December 1, 2012

Kubuntu Hidden Wireless Network

There seems to be general issue with KDE's Network Manager and hidden wireless networks. [You can see (and vote for!) the bug here:] You are trying to connect to a hidden network, and you create a profile for the specific wireless network in the KDE Network Manager. But for some reason you still can't connect.

I have encountered this problem for a while (Kubuntu 9.10, 10.04, 10.10, 11.04, 11.10, 12.04, and 12.10], but I finally found a solution today. A quick look tells me this bug has been around existed at least for 2 years. Pity they haven't fixed it.

Quick solution is to run this from command line:
sudo iwconfig wlan0 essid name_of_the_hidden_essid
This works even better if you have used KDE Network Manager to create a wireless profile with this hidden network's name already. You can setup password and such. This command only invokes connection to it, which is the real bug in the manager. It will read the profile you have previously stored.

Other solutions are to use a different network Manager, such as the network manager from Gnome/Ubuntu.

An even easier solution would be to just start broadcasting the SSID.

Tuesday, November 6, 2012

Disable Firefox Save Images to Changing Directories

Here is how to disable a feature in Firefox that can be really annoying if it doesn't work properly. [For me it only worked correctly 1/6th of the time, resulting in more work overall.]

The feature: Save Location Assistance/Guessing - Some time ago Firefox added a feature where it would try to guess which you wanted to save the current image/file to on your harddrive. It jumps to a previous location where you saved something that it thinks is similar, in the hopes of saving you the time for navigation your folder structure to save it.

The algorithm Mozilla uses unfortunately doesn't work much of the time. (I have to admit I think whatever implementation they used it is fairly dumb, meaning very ineffective.)

Here is how to disable this well meaning but ultimately inefficient and annoying (and somewhat destructive) feature behavior.

1). Open the about:config page. To open the about:config page, type about:config in the location (address) bar and press the "Enter" key, just like you type the url of a website to open a website.
If you see a warning then you can confirm that you want to access the about:config page.

2) Create a new value, of type Boolean, via the right-clicking with mouse to bring up the right-click menu. The name for the new Boolean value should be  "" (without the quotes).

3) Set the value to "false" (again without the quotes). You can do this by right clicking on the item you just created.

Some extra info on navigating the about:config page:
  • Use the Search (Filter) bar at the top of the about:config page to locate preferences more easily.
  • Preferences that have been modified show as bold (user set).
  • Preferences can be reset to the default via the right-click mouse menu if they are user set
  • Preferences can be changed via the right-click context menu: Modify (String or Integer) or Toggle (Boolean) or by double-clicking the line with the pref

Monday, September 17, 2012

LibreOffice 3.6 from PPA problems

Background of the Problem

This happened in my Kubuntu/Ubuntu 12.04 Precise. Up until a few weeks ago, my copy of LibreOffice version 3.6 from the PPA was working great. [It was faster, more stable, more bug fixes and even some new much needed features.]

But then suddenly it just stopped working. I still don't know why this happened exactly, though I have finally been able to track the cause to the probable package that triggered the whole meltdown.

When I tried running LibreOffice through the apps menu, nothing happened. So I ran the command 'libreoffice' from console, and got the error message:
/usr/lib/libreoffice/program/oosplash: not found
I wasn't sure what this problem was. I thought maybe some dependency had gone bad.

Unsuccessful Things I Tried

(1) I found I did not have a Java JRE installed, so I installed default-jre. But this didn't help.

(2) Try to reinstall LibreOffice, but APT tells me it cannot reinstall the libreoffice package back of broken packages. So manually remove extra libreoffice components.
apt-get remove --purge libreoffice-core libreoffice-writer libreoffice-calc libreoffice-impress libreoffice-draw libreoffice-math libreoffice-base
First try ininstalling LibreOffice, but cannot. APT eventually tells me:
The following packages have unmet dependencies:
  libreoffice : Depends: libreoffice-core (= 1:3.5.4-0ubuntu1.1) but it is not going to be installed
    Depends: libreoffice-writer but it is not going to be installed
    Depends: libreoffice-calc but it is not going to be installed
    Depends: libreoffice-impress but it is not going to be installed
    Depends: libreoffice-draw but it is not going to be installed
    Depends: libreoffice-math but it is not going to be installed
    Depends: libreoffice-base but it is not going to be installed
    Recommends: libreoffice-gnome but it is not going to be installed or
    libreoffice-kde but it is not going to be installed
E: Unable to correct problems, you have held broken packages.
(3) I had been using this PPA:

Tried using the program ppa-purge; even let it remove 100 separate packages at one point in order to "undo" the integration from this PPA that was probably causing problems on my system. But it did nothing to fix the problem!

(4) Tried manually editing the file /var/lib/dpkg/status, to check for a false positive on the program but nothing weird was installed or remaining! [Though I could not find anywhere it

Successful Fix (Part 1)

Here is what I did that finally fixed the dependency problem. While manually trying to install libreoffice-core, I noticed the error message said:
libreoffice-core : Depends: libexttextcat0 (>= 2.2-8) but it is not going to be installed
I checked out libexttextcat0 and it said:
libexttextcat0 : Depends: libexttextcat-data (= 3.2.0-1ubuntu1) but 3.3.1-2~precise1 is to be installed
Finally I used 'apt-cache policy' to look at libexttextcat-data and it said:
  Installed: 3.3.1-2~precise1
  Candidate: 3.3.1-2~precise1
  Version table:
 *** 3.3.1-2~precise1 0
        100 /var/lib/dpkg/status
     3.2.0-1ubuntu1 0
        500 precise/main amd64 Packages
This library had installed a later version (3.3.1-2) from somewhere that was no longer in my apt-repositories and apt couldn't figure this out (as being a serious problem for fixing via downgrade).

So I removed both libexttextcat-data and libexttextcat0 and then tried to install LibreOffice. Suddenly everything was ready to work again! But then came part 1.5.

Successful Fix (Part 1.5) The System is Unclean

At this point, I tried installing version LibreOffice 3.6 again from the PPA. This actually worked and installed just fine and it ran just fine. However I was a little worried about leftover crud from the prior botched installs.

After successfully installing LibreOffice 3.6, I purge uninstalled it and all its associated programs. Then I ran a check on the system, and sure enough found a bunch of left-over crud that hadn't been removed.

Successful Fix (Part 2)

So now I was left with a lot of crud left over from the previous botched installation of LibreOffice 3.6 which would simply not be uninstalled because the system (APT/DPKG) thought it wasn't installed.

This was going to require manual clean up, but thankfully it's not a very difficult task in Linux. I had to manually run a search-and-delete every single copy of anything related to LibreOffice on my system. After every trace of libreoffice named files were gone from my system, I was ready to install libreoffice for the final time.

However now if I tried to installed LibreOffice 3.6 from the PPA, the package maintainer (APT) behaved strangely. It acted like it installed the programs but actually did NOT install them. Nothing happened. So I used the command:
ppa-purge ppa:libreoffice/ppa
And removed the LibreOffice 3.6 PPA version and repository, and downgraded the program to version 3.5, installing from the official Ubuntu repositories and everything worked.

Word to the Wise: If you are installing a package and it asked you about installing a Configuration file, and you need to choose to keep your old file or install the Package-Maintainer's version, ALWAYS install the package maintainer's version, unless you have a really good reason not to.

Tuesday, September 11, 2012

Pidgin 2.10.6 Segfault Workaround

Pidgin Segfault Workaround

Today when I turned on my computer, Pidgin would not start. I normally prefer writing a more complete blog post, and I wish I had more to tell viewers but all I know is a (complex?) workaround that worked for me.

Pidgin won’t start. So I run it through command line. Get the message “Segfault”. Run it with the --debug switch. Get more info, but nothing conclusive. Check logs, find kernel describing a library problem with libc.

[   57.444660] pidgin[2211]: segfault at 0 ip 00007fc78073966a sp 00007fffee194710 error 4 in[7fc7806af000+1b3000]

Okay, that's bad but my system updated libc a week ago. Why the problem now? Try for a while but can't discover exact cause of problem.

My solution? Compile Pidgin myself, to see if that will fix the problem. Short answer: Yes, that fixed the problem.

I enabled software-sources in my apt-repository list, ran apt-get build-dep pidgin, manually download the pidgin source and compiled that sucker. Works fine, and I could remove all the extra packages installed by the apt-get build-dep move, with the exception of libfarstream, which is how Pidgin does it's sound.

Pidgin sound without gstreamers

Modern versions the instant messenger client Pidgin use gstreamers for their sound management. Sometimes you need to operate without gstreamers present on your system. But you still want sound though.

Here's a quick solution I've used in years passed. Go to Preferences -> Sounds -> Select "Method" and choose "Command". This will enable the input area with the label "Sou/nd command (%s for filename)". Into this box put this command:

aplay %s

That passes the sound from Pidgin to ALSA, which is supported on all modern Linux distributions and is also supported with backwards compatibility by PulseAudio.

Friday, September 7, 2012

Enable Auto Load with Firefox AutoPager

Hello. If you are using Firefox's add-on "AutoPager" you may have been annoyed in the past that it is inconveniently difficult to enable "Always autopage" on every sight you visit. (Essentially, you want to only use a blacklist of blocked autopage sites, and assume everything else is good.)

In the past, I don't even know how I set this. It may have been a menu or button option which has since been removed, but now for the latest Autopager, it is simply IMPOSSIBLE to enable all pages to automatically autopage.

Here is how I finally got this to work:

In Firefox, open a new tab and go to the address: "about:config" with no quotes and no http or anything. Just those words.

In the search area, type the words: extensions.autopager.noprompt

Set the value to 'True' and close. That should be all you need.

Friday, August 17, 2012

BTNX for Ubuntu 12.04 Precise

I thought that the wonderful mouse button configuration programs, btnx and btnx-config, were both available in the Ubuntu 12.04 repositories. Well, apparently they aren't? [But they were for a time, and I don't know why they were removed.]

UPDATE: For those running 12.10, I have posted a slightly dirty but workable solution here. Hopefully someone will take my patches and make a PPA of btnx. I'm looking it myself but it feels like a lot of work.

btnx is the best mouse-button configuration program I have found, bar-non, in any operating system so far. (I've tried others but they are either too complicated OR don't do the simple things I wanted.)

To install btnx in Ubuntu 12.04 (assuming Ubuntu doesn't fix this glaring error themselves), just download the appropriate version for yourself:
Look under the "Downloadable files" section. Don't grab the file for Oneiric, because that's the wrong version for 12.04 precise.

For example, you would want to download this sort of file (if you were running 64-bit): btnx_0.4.11-3ubuntu2_amd64.deb (19.3 KiB)

Make sure to get both the main program and the gui. After you have downloaded them, you need to install them. You may be able to install them using a graphical program, and then resolving the dependencies later. My approach was a little different and slightly more advanced but I knew exactly what was going on.

I opened a command console window, changed directories to where I had downloaded the btnx *.deb files, and ran the following command:

sudo dpkg -i btnx*

It proceeded to partially install the programs, but had a dependency error. I then ran this command to fix the dependency problem:

sudo apt-get install -f

In my case, this installed the dependency package 'menu'. Then btnx was successfully unpacked and installed. Now, btnx tried to auto-start its service after this but had an error. However when I manually ran the program manually through the applications menu, it opened just fine. I fed it my previously saved config files and everything worked.

Wednesday, July 18, 2012

Extract from DVDs/ISO in Ubuntu

Just a quick post. If you ever need to simply extract data from DVDs or ISO images in Ubuntu, I whole heartedly recommend the program K9Copy. Searching the Ubuntu Software Center for "DVD Rip" or "DVD Extract" unfortunately does not provide this awesome program in the search results.

I only found it because I knew of it previously. It is extremely useful for opening an pre-ripped DVD-ISO file and extracting the data streams from it. As usual, I'm sharing this because I found it useful to know. Hope it helps someone out there.

P.S. Does anyone know how to tag programs in the Ubuntu Software Center with key words? K9Copy should absolutely be listed when you search for DVD Ripping.

Thursday, June 21, 2012

Linux Irks: Things in Linux that Irk You

An Open Question to Users

So this post is a bit different. This question goes out to all Linux users (casual, professional, full-time/part-time, whatever).

"What are your Linux irks? What are the things in Linux that irk you?" Just to clarify, this isn't a feature request thread. Not a "I wish feature X-Y-Z was in Linux." Mostly I am thinking of things like "I can live the situation; the workaround I have functions okay, but I wish they'd fix it or it was better." I'll start as an example (see below).

Can be big, small, significant or insignificant. This isn't a flame thread, so if you please, try to be polite and rant-free. (I know I rant sometimes. I try not to...)

Side Comment

I read the Phoronix news posts daily and semi-daily. There's a fair bit of graphics related Jargon to get used to and if you aren't a graphics enthusist, that website may not be for you. However they do cover much more than just graphics, though that seems to be their big passion.

I really love Linux, but I have to admit it's not perfect. There is a recent article about the state of much of Linux hardware support and honestly I think the poster did a good job of politely pointing out serious shortcomings while also presenting triumphs. Read it here if you are interested in getting a fairly realistic and well supported opinion on the state of Linux hardware support.


Not many things irk me about Linux (or my Linux experience), but:

1) EDIT -- A friend of mine kindly pointed out the solution to this problem a few weeks ago (on a day when I was particularly angry too, so it was very nice). The short version is: I needed to enable "USB Keyboard support and also USB mouse support" in my BIOS. So if you are having this problem, please poke around in your BIOS or google for the solution to your particular BIOS.

Legacy Post (SOLVED): One recently that continues to bite me is GRUB's USB-wireless keyboard support. My usb-wireless keyboard "Logitech DiNovo Edge" works great in Linux/KDE (after a simple one-time tweak for each Linux distribution update/install.) It works on boot-up in my BIOS, which is awesome. It works in Linux rescue disks in the basic consoles. It works in KDE/Gnome/Fluxbox/KMS/VirtualBox, you name it.

But when GRUB loads to ask me a question (sometimes after I install or remove kernels, or swap around harddrives), my usb-wireless keyboards STOPS WORKING. Rage.

Sigh... I've dealt with this problem for literal years now. I still keep a PS2 keyboard around to fix the problem. Though I should check if GRUB2 now supports just play non-wireless USB keyboards.

2) Missing out of the box multi-button mouse configuration. (I assert this must be a graphical configuration tool, since mice are fundamentally graphical.) I understand that not everyone will have a multi-button mouse, but I wish KDE, Gnome, or Debian/Ubuntu themselves made an officially supported project to handle these. I know it probably couldn't work for everything, but if someone started it as an officially supported project, people could build plugins for it and then it would be a widespread well supported project covering much of the FOSS and Linux world.

I use a Logitech multi-button mouse and I use BTNX to configure it. This works very very well, and I'm quite happy. However occasionally the BTNX package has been unavailable in versions of Ubuntu. One time it disappeared because of Kernel driver API changes, but several months later this was adjusted for. Another time, just recently with Ubuntu 12.04, it wasn't available for a month until a third-party library dependency issue could be resolved and BTNX could be made available for the latest Ubuntu version.


I'm in a somewhat privileged position... (maybe?) I don't play video games so the lack of game support on Linux rarely impacts me.

Friday, June 15, 2012

Leaving Ubuntu or Staying Ubuntu?


This is a thought piece, related to my choice of Linux Distribution Ubuntu. Recently I thought about moving from Ubuntu to some other Linux Distribution.


Some of what brought on these thoughts are as follows (in no particular order):
  1. Firefox kde support being dropped.
    I personally loved this package and would really struggle to live without it now.
  2. Kubuntu being dropped by Ubuntu
    I have never liked Gnome, either versions 1, 2, or 3. I have always felt that with rare exception KDE was a superior desktop environment. (The biggest exception being the initial development and release of KDE 4, which was a colossal debacle to even its staunchest supporters. Why KDE? Just WHY!?)

    But I certainly don't think Gnome2 was bad. (I have no opinion on Gnome3, since I've really never used it or 2 enough to know the difference.)
  3. Focused move onto Unity (and thus on Gnome).
    Again, I don't use Unity at all (or Gnome) nor particularly like it. I've even felt it was a hinderance to the Linux Desktop adaption worldwide because Gnome is not as similar to the Windows Desktop as KDE is. But again, that's only my limited opinion.
At the time of these things happening (especially items #1 and #2), I began to worry that Ubuntu might be moving in a direction that would ultimately not support my needs as a user.

Where to go for an alternative?

If I am going to pick a new distro, what are my other options?:
  • Red Hat/Fedora: Not Debian, and possible stability issues compared to Debian based systems. (Again, only possible ones. I'm not flaming here.). On the plus side it does include Firefox-Kde-Support natively, I think. But I would miss the apt-package system, which I love a lot. I also would miss the Ubuntu PPAs, which are darn useful.
  • Debian: Doesn't keep up enough. I have to wait too long for kernel updates with important features that enhance performance and graphics and fix bugs.
  • OpenSuse: Not based on a Debian system, which puts me at a disadvantage. I've been using Debian since I started Linux. On the plus side it does include Firefox-Kde-Support, I think.

The Real Issue

Eventually I realized my alternatives were not what was important. The ultimately important question is what really matters: "What do I want from a distribution of Linux?"

My answers so far:
  • KDE 4 (with desktop effects)
  • BTNX (Button Configuration for my mouse)
  • Firefox (with KDE integration) (latest)
  • Gimp (very recent versions)
  • VLC (very latest)
  • Eclipse
  • Vim
  • Ssh
  • Amarock
  • Gwenview (very latest)
  • Konqueror
  • LiberOffice (very latest)
  • Wine (very latest)
  • Pidgin IM (very latest)
  • Proprietary Driver installation (easy and convenient installation)
  • Wacom Tablet support
  • Synergy
  • Avidemux (very latest)
  • Klipper
  • Workrave
  • Regular updates to keep as current as possible while also maintaining as much stability as possible
A lot these things I want (mostly software packages) can be found in other distributions of Linux.

Some Pro's for Ubuntu

  • Ubuntu Software Center: Great idea and pretty good execution, plus they keep adding more stuff to it.
  • Ubuntu is really really popular: It's a namebrand that third-party software contributors and developers actually account for, more than most other distributions of Linux.
  • PPAs: These are just awesome.
  • Finance Support: Ubuntu is making a lot of money and has a good backing. They are also pushing their technology into new areas and trying new things. Even if I don't always like or care for what they do, that's something to be admired.
  • Ubuntu for Android: Just plain awesome, especially because I so want to use this for my next phone.


I started writing this about two months ago and now as I finish it, I am happy to report all of my issues have been solved.
  • Kubuntu's Future: Kubuntu received funding from another external backer. (I believe they were offered backing by a couple of companies.) They aren't going anywhere, and in fact this may be a better move for them in the future.
  • Firefox kde support: Firefox kde support has been provided by a member of the Ubuntu Community, which is very awesome. This just demonstrates how the Ubuntu PPAs are a great aspect of the Ubuntu community. I was considering whether I should step up to providing a PPA to solve this problem, but someone did it for me.
  • Ubuntu's focus on Unity: Unity has been around for years now and I've been mostly unaffected sitting in my KDE castle. So, why start to worry now with Kubuntu backed by external parties?
Lastly I have seen the Ubuntu community work hard to support various packages and software I care about. People really try to help and support a lot. Just today I found that Ubuntu had added the 'btnx' and 'btnx-config' packages back into their repository, after they had been disabled a few weeks ago due to a bug preventing readiness for OS version 12.04. This just showed me in a small way they are doing a lot of what I want from a distribution.

So yeah, I'm staying with Kubuntu/Ubuntu. I hope other's experiences are generally as good or better than mine as well. Peace all. :)

MyBookLive SSH

Just a quick story here to share how I regained SSH login access to my "MyBookLive" after doing a firmware upgrade (earlier this week) and randomly losing access. After the reboot suddenly I could not log in via SSH. However the web-page UI was available.

To enable SSH on it, you must first go to: http://mybooklive/UI/ssh, but it was already enabled for me. This was not the problem. After changing all the passwords I could find and trying the default one, nothing worked. I still could not log in via SSH. (It appeared all my SSHD settings were reset to defaults, such as back to default port 22.)

So after making sure all my data was duplicated, I used a paperclip to press the tiny reset button on the back of the machine.
I had done some research and for my MBL (pictured above) this does NOT wipe out the data apparently. It runs a shell script which resets many of the login passwords and I believe some ownership permissions but mostly on the web-interface and SSH.

After doing this, I was able to log in with the default password and change whatever I wanted. As seems normal with firmware updates, any extra programs I installed on the machine (through commandline via remote ssh login) were uninstalled. But thankfully it is a trivial thing to reinstall.

One last word, if you are going to use SSH, please be careful as the commandline is a powerful (but relatively unforgiving) tool. You can screw up your system if you don't know what you are doing. Also, if you are going to leave SSH enabled and you leave your machine on the internet for long periods of time (as most of us do), please consider changing the default SSH settings for safety and security. Choose a non-standard port to run your SSH on. (Anything above 1024 is good. Pick a random number in the many thousands, and stick with it.) I also make a white-list of allowed user names to login and forbid 'root' to login remotely.

Sunday, June 10, 2012




So if you are using KDE and running Firefox, and if you haven't been using the extra-functionality of "Firefox-KDE-Support", you are really missing out. This modifications make use of the truly excellent KDE/QT file-selector dialogs, among some other more under-the-hood changes.

In fact, the KDE/QT file-selector is hands-down the best file open/save dialog in the world, bar none. After using this, I really can never go back to using the GTK file open dialogs for frequent intense use.

(Opinion: I save a ton of files in my browser every day. In my opinion, the GTK file dialog is  just broken on a few key features, like hover previews for images, and auto-highlighting existing filenames in current directory. Small features, yes, but I use them literally every day many times a day.)

Ubuntu/Kubuntu version 11.10 and prior

In Ubuntu/Kubuntu version 11.10 and prior, simply install the package 'firefox-kde-support', restart your firefox and you will be good to go.

Ubuntu/Kubuntu version 12.04 and later

Sadly Kubuntu dropped their Firefox-KDE-Support package. But fear not! I have a solution for you. (though I didn't make it. I'm just passing it along!)

Background on why it was dropped

Concerning the information about the dropping, I know why the support is being dropped and though it saddens me I don't blame the maintainer. Mostly it was a fair bit of work and he didn't want to commit to doing it again for another five-years to coincide with the Ubuntu ultra-longterm release of 12.04. (In fact, on the Phoronix forums thread for the issue, I'm a little ashamed of the rude comments from some people, and I shake my head at some of the kooks who can't live with software where they "didn't compile every byte themselves." Yes, that's an exact quote from a few... sigh. These people are why Linux sometimes gets bad Public Reputations. But I digress.)

Firefox KDE Support for Ubuntu/Kubuntu 12.04 and later

Some awesomely helpful soul has created a version of Firefox with the KDE support bundled right in and created a PPA for the files. Here is the original post from the awesome contributor found on the Kubuntu forums:
I've uploaded both kmozillahelper (firefox-kde-support) and firefox 12 / firefox 13 with KDE patches re-enabled here:
It should be built in couple hours so you can try it if you want.
Tested both packages and everything is working - plasma notifications, file associations, and KDE dialogs
That link again:

Some useful links

Here is the link to where I believe the source code for the modifications in Firefox are. This is mostly just here for reference.

Friday, May 25, 2012

How to Disable Profile Pictures in Gmail

How to Disable (Other) Profile Pictures in Gmail

A short while ago changed Gmail to display the profile photos/pictures of the people who send you email and whom you chat with. I don't like this feature, since sometimes I receive emails from online services, and when it shows up with a random person's face I've never met, it is unsettling. Here is how to disable the "People Widget" in your Gmail.

Go to: Gmail -> Settings -> General -> People Widget -> Hide the people widget.

Simple huh? Well, it is subtle and took me some time to find. Heck, I was able to google it a few weeks ago but then today I couldn't find the answer on Google no matter what I tried. I wouldn't have known the option was there if I hadn't already found the solution.

What they really need is a whitelist option, since there are a few people I actually would like to see this People Widget used for, but for 95% of all the email I get, I really never want to see these people.

(On a personal note, I hate Facebook's outright oppression of anonymity online. I just hope Google never goes that route.)

Wednesday, May 2, 2012

Google Talk Audio Fluxuation Problems


Fixing (randomly changing/auto-adjusting) audio levels for Google Talk (Google Voice) microphone in Linux.


So I started using Google Voice chat a lot in the past few months. But just this passed week, I noticed the microphone volume was automatically increasing itself, until it became too loud for others in the conversation. I don't know why it suddenly started, but here is the solution to the problem. (I recently upgraded to Firefox 12 and this might be the change that caused the problem.)


Google Talk voice chat has an configuration file called 'options' in the folder '~/.config/google-googletalkplugin'. You want to edit this file or create it for yourself.

Make a backup '~/.config/google-googletalkplugin/options'. If the file does not exist, don't worry. Just create one. Edit file and add this line:


If you need help editing a file in Linux, see this article.

Tuesday, April 10, 2012

Debian 5.0 Package Authentication

I've got a GNU Linux Debian 5.0 machine here. It's a Western Digital "MyBookLive" sort of machine. Network storage and media device. Have some nice features and runs Linux under the hood. You can log in with SSH and use the command line. I decided this machine needed to be updated with the latest security patches, since I'm use sure it hasn't happened in a long time.

When running the apt-get update command, I get this warning:
WARNING: GPG error: squeeze Release: The following signatures couldn't be verified because the public key is not available: NO_PUBKEY AED4B06F473041FA

"WARNING: The following packages cannot be authenticated!"
The solution to this is to add the appropriate 'apt-keys' to allow for package digital signature verification. You can do this in Ubuntu as well, since it uses the Debian Package system. (Debian's apt system is one of my favorite features of the distro and all it's derivatives.) You use the program gpg to download the relevant key, fingerprint it, and export it into your armory while adding it as an apt-key.
gpg --keyserver --recv AED4B06F473041FA
gpg --fingerprint AED4B06F473041FA
gpg --export --armor AED4B06F473041FA | sudo apt-key add -
Interesting I don't actually KNOW any Debian Key-server addresses, so I had to use an Ubuntu one, but I knew they would have it. Do this and your package authentication should work.

UPDATE: I discovered the updates I was trying to apply didn't work. Had an unusual error when trying to unpack the dpkg_1.15.8.12_powerpc.deb file. So I went through the web-interface to the device and tried to update there. Fixed the problem, but in an unexpected way. It seemed to roll the system back to previous set-point. Still, fixed my problem, and undid every change I made. I'm not complaining, since it did restore the system to proper working order. I'm not sure if my tweaks were what caused this or not. It even reset my SSHD configurations. (Should always use a non-standard port and limit allowed your users.)

Still, using the above solution does allow me to authenticate any new packages I want to install.